Project Chrono: chrono::ChStaticNonLinearAnalysis Class Reference

Public Member Functions | Friends | List of all members
chrono::ChStaticNonLinearAnalysis Class Reference

## Description

Nonlinear static analysis.

`#include <ChStaticAnalysis.h>`

Inheritance diagram for chrono::ChStaticNonLinearAnalysis:
[legend]
Collaboration diagram for chrono::ChStaticNonLinearAnalysis:
[legend]

## Public Member Functions
void | SetVerbose (bool verbose)
| Enable/disable verbose output (default: false).
void | SetMaxIterations (int max_iters)
| Set the max number of iterations for the Newton Raphson procedure (default: 10).
void | SetIncrementalSteps (int incr_steps)
| Set the number of steps that, for the first iterations, make the residual grow linearly (default: 6).
void | SetCorrectionTolerance (double reltol, double abstol)
| Set stopping criteria based on WRMS norm of correction and the specified relative and absolute tolerances.
void | SetResidualTolerance (double tol)
| Set stopping criteria based on norm of residual and the specified tolerance.
int | GetMaxIterations () const
| Get the max number of iterations for the Newton Raphson procedure.
int | GetIncrementalSteps () const
| Set the number of steps that, for the first iterations, make the residual grow linearly.
Public Member Functions inherited from chrono::ChStaticAnalysis
ChIntegrable * | GetIntegrable ()
| Get the integrable object.
const ChState & | GetStatePos () const
| Access the state, position part, at current analysis.
const ChVectorDynamic & | GetLagrangeMultipliers () const
| Access the Lagrange multipliers, if any.

## Friends
class | ChSystem

## Additional Inherited Members
Protected Member Functions inherited from chrono::ChStaticAnalysis
void | SetIntegrable (ChIntegrableIIorder *integrable)
| Set associated integrable object.
Protected Attributes inherited from chrono::ChStaticAnalysis
ChIntegrableIIorder * | m_integrable
ChState | X
ChVectorDynamic | L

## Member Function Documentation

## ◆ SetCorrectionTolerance()

void chrono::ChStaticNonLinearAnalysis::SetCorrectionTolerance | ( | double | reltol,
|  | double | abstol )

Set stopping criteria based on WRMS norm of correction and the specified relative and absolute tolerances.

This is the default, with reltol = 1e-4, abstol = 1e-8. The Newton Raphson procedure is stopped if the WRMS norm of the correction vector (based on the current state) is less than 1.

## ◆ SetIncrementalSteps()

void chrono::ChStaticNonLinearAnalysis::SetIncrementalSteps | ( | int | incr_steps | ) |

Set the number of steps that, for the first iterations, make the residual grow linearly (default: 6).

If =0, no incremental application of residual, so it is a classic Newton Raphson iteration, otherwise acts as a continuation strategy. For values > 0 , it might help convergence. Must be less than maxiters.

## ◆ SetResidualTolerance()

void chrono::ChStaticNonLinearAnalysis::SetResidualTolerance | ( | double | tol | ) |

Set stopping criteria based on norm of residual and the specified tolerance.

The Newton Raphson is stopped when the infinity norm of the residual is below the tolerance.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/timestepper/ChStaticAnalysis.h
- D:/W/B/src/chrono-9.0.1/src/chrono/timestepper/ChStaticAnalysis.cpp